/**
 * TEL.java
 *
 * File generated from the medication::TEL uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class TEL.
 *
 * 
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "TEL", propOrder = {
	"useablePeriod",
	"use"
})
@XmlRootElement(name = "TEL")
public class TEL extends net.ihe.gazelle.medication.URL1 implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *                       Specifies the periods of time
	                                during which the                      telecommunication address can
	                                be used.  For a                      telephone number, this can
	                                indicate the time of day                      in which the party can
	                                be reached on that telephone.                      For a web
	                                address, it may specify a time range in                      which
	                                the web content is promised to be available
	                                under the given address.                   .
	 */
	@XmlElement(name = "useablePeriod", namespace = "urn:epsos-org:ep:medication")
	public List<net.ihe.gazelle.medication.SXCMTS> useablePeriod;
	/**
	 *                       One or more codes advising a system
	                            or user which                      telecommunication address in a set of
	                            like addresses                      to select for a given
	                            telecommunication need.                   .
	 */
	@XmlAttribute(name = "use")
	public java.lang.String use;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return useablePeriod.
	 * @return useablePeriod :                       Specifies the periods of time
	                                during which the                      telecommunication address can
	                                be used.  For a                      telephone number, this can
	                                indicate the time of day                      in which the party can
	                                be reached on that telephone.                      For a web
	                                address, it may specify a time range in                      which
	                                the web content is promised to be available
	                                under the given address.                                         Specifies the periods of time
	                                during which the                      telecommunication address can
	                                be used.  For a                      telephone number, this can
	                                indicate the time of day                      in which the party can
	                                be reached on that telephone.                      For a web
	                                address, it may specify a time range in                      which
	                                the web content is promised to be available
	                                under the given address.                                         Specifies the periods of time
	                                during which the                      telecommunication address can
	                                be used.  For a                      telephone number, this can
	                                indicate the time of day                      in which the party can
	                                be reached on that telephone.                      For a web
	                                address, it may specify a time range in                      which
	                                the web content is promised to be available
	                                under the given address.                                         Specifies the periods of time
	                                during which the                      telecommunication address can
	                                be used.  For a                      telephone number, this can
	                                indicate the time of day                      in which the party can
	                                be reached on that telephone.                      For a web
	                                address, it may specify a time range in                      which
	                                the web content is promised to be available
	                                under the given address.                                         Specifies the periods of time
	                                during which the                      telecommunication address can
	                                be used.  For a                      telephone number, this can
	                                indicate the time of day                      in which the party can
	                                be reached on that telephone.                      For a web
	                                address, it may specify a time range in                      which
	                                the web content is promised to be available
	                                under the given address.                                         Specifies the periods of time
	                                during which the                      telecommunication address can
	                                be used.  For a                      telephone number, this can
	                                indicate the time of day                      in which the party can
	                                be reached on that telephone.                      For a web
	                                address, it may specify a time range in                      which
	                                the web content is promised to be available
	                                under the given address.                                         Specifies the periods of time
	                                during which the                      telecommunication address can
	                                be used.  For a                      telephone number, this can
	                                indicate the time of day                      in which the party can
	                                be reached on that telephone.                      For a web
	                                address, it may specify a time range in                      which
	                                the web content is promised to be available
	                                under the given address.                   
	 */
	public List<net.ihe.gazelle.medication.SXCMTS> getUseablePeriod() {
		if (useablePeriod == null) {
	        useablePeriod = new ArrayList<net.ihe.gazelle.medication.SXCMTS>();
	    }
	    return useablePeriod;
	}
	
	/**
	 * Set a value to attribute useablePeriod.
	 * @param useablePeriod :                       Specifies the periods of time
	                                during which the                      telecommunication address can
	                                be used.  For a                      telephone number, this can
	                                indicate the time of day                      in which the party can
	                                be reached on that telephone.                      For a web
	                                address, it may specify a time range in                      which
	                                the web content is promised to be available
	                                under the given address.                                         Specifies the periods of time
	                                during which the                      telecommunication address can
	                                be used.  For a                      telephone number, this can
	                                indicate the time of day                      in which the party can
	                                be reached on that telephone.                      For a web
	                                address, it may specify a time range in                      which
	                                the web content is promised to be available
	                                under the given address.                                         Specifies the periods of time
	                                during which the                      telecommunication address can
	                                be used.  For a                      telephone number, this can
	                                indicate the time of day                      in which the party can
	                                be reached on that telephone.                      For a web
	                                address, it may specify a time range in                      which
	                                the web content is promised to be available
	                                under the given address.                                         Specifies the periods of time
	                                during which the                      telecommunication address can
	                                be used.  For a                      telephone number, this can
	                                indicate the time of day                      in which the party can
	                                be reached on that telephone.                      For a web
	                                address, it may specify a time range in                      which
	                                the web content is promised to be available
	                                under the given address.                                         Specifies the periods of time
	                                during which the                      telecommunication address can
	                                be used.  For a                      telephone number, this can
	                                indicate the time of day                      in which the party can
	                                be reached on that telephone.                      For a web
	                                address, it may specify a time range in                      which
	                                the web content is promised to be available
	                                under the given address.                                         Specifies the periods of time
	                                during which the                      telecommunication address can
	                                be used.  For a                      telephone number, this can
	                                indicate the time of day                      in which the party can
	                                be reached on that telephone.                      For a web
	                                address, it may specify a time range in                      which
	                                the web content is promised to be available
	                                under the given address.                                         Specifies the periods of time
	                                during which the                      telecommunication address can
	                                be used.  For a                      telephone number, this can
	                                indicate the time of day                      in which the party can
	                                be reached on that telephone.                      For a web
	                                address, it may specify a time range in                      which
	                                the web content is promised to be available
	                                under the given address.                   .
	 */
	public void setUseablePeriod(List<net.ihe.gazelle.medication.SXCMTS> useablePeriod) {
	    this.useablePeriod = useablePeriod;
	}
	
	
	
	/**
	 * Add a useablePeriod to the useablePeriod collection.
	 * @param useablePeriod_elt Element to add.
	 */
	public void addUseablePeriod(net.ihe.gazelle.medication.SXCMTS useablePeriod_elt) {
	    this.useablePeriod.add(useablePeriod_elt);
	}
	
	/**
	 * Remove a useablePeriod to the useablePeriod collection.
	 * @param useablePeriod_elt Element to remove
	 */
	public void removeUseablePeriod(net.ihe.gazelle.medication.SXCMTS useablePeriod_elt) {
	    this.useablePeriod.remove(useablePeriod_elt);
	}
	
	/**
	 * Return use.
	 * @return use :                       One or more codes advising a system
	                            or user which                      telecommunication address in a set of
	                            like addresses                      to select for a given
	                            telecommunication need.                                         One or more codes advising a system
	                            or user which                      telecommunication address in a set of
	                            like addresses                      to select for a given
	                            telecommunication need.                                         One or more codes advising a system
	                            or user which                      telecommunication address in a set of
	                            like addresses                      to select for a given
	                            telecommunication need.                                         One or more codes advising a system
	                            or user which                      telecommunication address in a set of
	                            like addresses                      to select for a given
	                            telecommunication need.                                         One or more codes advising a system
	                            or user which                      telecommunication address in a set of
	                            like addresses                      to select for a given
	                            telecommunication need.                                         One or more codes advising a system
	                            or user which                      telecommunication address in a set of
	                            like addresses                      to select for a given
	                            telecommunication need.                                         One or more codes advising a system
	                            or user which                      telecommunication address in a set of
	                            like addresses                      to select for a given
	                            telecommunication need.                   
	 */
	public java.lang.String getUse() {
	    return use;
	}
	
	/**
	 * Set a value to attribute use.
	 * @param use :                       One or more codes advising a system
	                            or user which                      telecommunication address in a set of
	                            like addresses                      to select for a given
	                            telecommunication need.                                         One or more codes advising a system
	                            or user which                      telecommunication address in a set of
	                            like addresses                      to select for a given
	                            telecommunication need.                                         One or more codes advising a system
	                            or user which                      telecommunication address in a set of
	                            like addresses                      to select for a given
	                            telecommunication need.                                         One or more codes advising a system
	                            or user which                      telecommunication address in a set of
	                            like addresses                      to select for a given
	                            telecommunication need.                                         One or more codes advising a system
	                            or user which                      telecommunication address in a set of
	                            like addresses                      to select for a given
	                            telecommunication need.                                         One or more codes advising a system
	                            or user which                      telecommunication address in a set of
	                            like addresses                      to select for a given
	                            telecommunication need.                                         One or more codes advising a system
	                            or user which                      telecommunication address in a set of
	                            like addresses                      to select for a given
	                            telecommunication need.                   .
	 */
	public void setUse(java.lang.String use) {
	    this.use = use;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "TEL").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(TEL tEL, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (tEL != null){
   			net.ihe.gazelle.medication.URL1.validateByModule(tEL, location, cvm, diagnostic);
			{
				int i = 0;
				for (net.ihe.gazelle.medication.SXCMTS useablePeriod: tEL.getUseablePeriod()){
					net.ihe.gazelle.medication.SXCMTS.validateByModule(useablePeriod, location + "/useablePeriod[" + i + "]", cvm, diagnostic);
					i++;
				}
			}
			
    	}
    }

}